day108—同向双指针—乘积小于K的子数组(LeetCode-713)

题目描述

给你一个整数数组 nums 和一个整数 k ,请你返回子数组内所有元素的乘积严格小于k 的连续子数组的数目。

示例 1:

复制代码
输入:nums = [10,5,2,6], k = 100
输出:8
解释:8 个乘积小于 100 的子数组分别为:[10]、[5]、[2]、[6]、[10,5]、[5,2]、[2,6]、[5,2,6]。
需要注意的是 [10,5,2] 并不是乘积小于 100 的子数组。

示例 2:

复制代码
输入:nums = [1,2,3], k = 0
输出:0

提示:

  • 1 <= nums.length <= 3 * 104
  • 1 <= nums[i] <= 1000
  • 0 <= k <= 106

解决方案:

  1. 维护一个乘积小于 k的滑动窗口 [left, i]

  2. 固定右端点 i时,找到满足 乘积 < k的最左边的 left

  3. 此时,以 i为右端点的所有连续子数组 中,满足条件的子数组个数为 i - left + 1

关键点:

  • 特殊判断:如果 k <= 1,因为所有数字都是正整数,乘积不可能小于 1 或 0,直接返回 0

  • 用变量 p记录当前窗口的乘积

  • 当加入新数字后 p >= k时,不断从左边移除数字(p /= nums[left]),直到乘积小于 k

  • 此时窗口 [left, i]内的所有连续子数组都满足乘积小于 k,且个数为 i - left + 1

  • 累加这些个数得到最终答案

为什么是 i - left + 1:

  • 当窗口为 [left, i]时,以 i为右端点的子数组有:

    • [left, i]

    • [left+1, i]

    • ...

    • [i, i]

  • 总共 i - left + 1个,且这些子数组的乘积都小于 k(因为整个窗口的乘积小于 k,去掉左边元素后乘积只会更小)

时间复杂度:O(n),每个元素最多被加入和移出窗口各一次

函数源码:

cpp 复制代码
class Solution {
public:
    int numSubarrayProductLessThanK(vector<int>& nums, int k) {
        if(k<=1)    return 0;

        int len=nums.size();
        int left=0;
        int ans=0;
        int p=1;//乘积

        for(int i=0;i<len;i++){
            p*=nums[i];
            while(p>=k){
                p/=nums[left];
                left+=1;
            }
            ans+=i-left+1;
        }
        return ans;

    }
};
相关推荐
怕浪猫30 分钟前
Super-agent 在各大模型厂商的应用情况
算法·面试·github
海绵宝宝转agent1 小时前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
octopus_c1 小时前
C++ 模板详解:函数模板、类模板、特化与分离编译
开发语言·c++·算法
東隅已逝,桑榆非晚1 小时前
算法1. 双指针法-移动零
c++·算法
CQU_JIAKE2 小时前
11.1[A]
算法
文丑颜不良啊2 小时前
LeetCode1581~1600题目解析
java·leetcode
小郎君6582 小时前
(六)el-cascader 的展示值为什么不能直接 join:emitPath、路径还原与多选去重
vue.js·算法
郝学胜-神的一滴4 小时前
游戏设计:原型与开发 19:U3D工位布置与性格说明书
人工智能·算法·unity·unreal engine·游戏策划·游戏设计
hahaha60165 小时前
数字图像时域滤波或者3D降噪算法FPGA实现
算法·计算机视觉·fpga开发
文丑颜不良啊5 小时前
LeetCode1541~1560题目解析
java·leetcode